unit Configurar_Conexao;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, DB, IBDatabase, Inifiles;

type
  TfrmConexao = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    OpenDialog1: TOpenDialog;
    IB: TIBDatabase;
    CheckRede: TCheckBox;
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmConexao: TfrmConexao;

implementation

uses Unit1, DataModule;

{$R *.dfm}

procedure TfrmConexao.SpeedButton1Click(Sender: TObject);
begin
if opendialog1.Execute then
   edit2.Text := opendialog1.FileName;
end;

procedure TfrmConexao.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = vk_escape then close;
if key = 13 then PostMessage(Handle, wm_nextdlgctl, 0, 0);
if key = 40 then PostMessage(Handle, wm_nextdlgctl, 0, 0);
if key = 38 then PostMessage(Handle, wm_nextdlgctl, 9, 0);
end;

procedure TfrmConexao.SpeedButton2Click(Sender: TObject);
begin
try
IB.Close;
IB.DatabaseName:=edit1.Text+':'+edit2.Text;
IB.Open;
showmessage('Conexo Realizada com Sucesso');
except
on E : exception do
showmessage('Conexo Falhou. Erro: '+E.Message);
end;
if IB.Connected = false then abort;
end;

procedure TfrmConexao.SpeedButton3Click(Sender: TObject);
begin
if ib.Connected = false then
   speedbutton2.Click;
try
Config := Tinifile.Create(Diretorio+'Config.dat');
if edit1.Text = '' then edit1.Text := 'localhost';
if CheckRede.Checked = true then
   Config.WriteString('BASE','REDE','SIM') else Config.WriteString('BASE','REDE','NAO');
Config.WriteString('BASE','IP',edit1.Text);
Config.WriteString('BASE','TABELA',edit2.Text);
if CheckRede.Checked = true then
Rede := True else Rede := False;
TCP := edit1.Text;
Conexao:= edit2.Text;
finally
Config.Free;
showmessage('Conexo Salva com Sucesso');
Dados.Base.Close;
Dados.Base.DatabaseName := TCP + ':' + Conexao;
Dados.Base.Open;
end;
end;

procedure TfrmConexao.FormCreate(Sender: TObject);
begin
try
Config := Tinifile.Create(Diretorio+'Config.dat');
if Config.ReadString('BASE','REDE','') = 'SIM' then CheckRede.Checked := True;
edit1.Text := Config.ReadString('BASE','IP','');
edit2.Text := Config.ReadString('BASE','TABELA','');
finally
Config.Free;
end;end;

end.
