unit Criar_Tabelas;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, StrUtils, ComCtrls, ExtCtrls, inifiles, IBServices;

type
  TfrmTabelas = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Label4: TLabel;
    EdTabela: TEdit;
    Label1: TLabel;
    edCampo: TEdit;
    Label2: TLabel;
    ComboTipo: TComboBox;
    Label3: TLabel;
    edTamanho: TEdit;
    SpeedButton1: TSpeedButton;
    EdPrecisao: TEdit;
    Unico: TCheckBox;
    Obrigatorio: TCheckBox;
    Label5: TLabel;
    Lista: TListBox;
    ComboChave: TComboBox;
    Label6: TLabel;
    SpeedButton4: TSpeedButton;
    SpeedButton3: TSpeedButton;
    GroupBox1: TGroupBox;
    ListaTabelas: TListBox;
    Panel1: TPanel;
    GroupBox2: TGroupBox;
    ListaCampos: TListBox;
    SpeedButton2: TSpeedButton;
    IBBackup: TIBBackupService;
    IBRestore: TIBRestoreService;
    Panel2: TPanel;
    BitBtn1: TBitBtn;
    SpeedButton6: TSpeedButton;
    PainelOpcao: TPanel;
    TELA: TNotebook;
    Label7: TLabel;
    adCampo: TEdit;
    Label8: TLabel;
    adTipo: TComboBox;
    Label9: TLabel;
    adTamanho: TEdit;
    Label10: TLabel;
    adPrecisao: TEdit;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    adNull: TCheckBox;
    adUnique: TCheckBox;
    PainelOrdem: TPanel;
    Acima: TSpeedButton;
    Abaixo: TSpeedButton;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    TabSheet3: TTabSheet;
    GroupBox3: TGroupBox;
    CheckBox1: TCheckBox;
    Label23: TLabel;
    Label24: TLabel;
    edLogin: TEdit;
    edSenha: TEdit;
    SpeedButton5: TSpeedButton;
    procedure EdTabelaKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EdTabelaExit(Sender: TObject);
    procedure edTamanhoKeyPress(Sender: TObject; var Key: Char);
    procedure edCampoExit(Sender: TObject);
    procedure edCampoKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ComboTipoExit(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure ComboTipoKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SpeedButton4Click(Sender: TObject);
    procedure ListaKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SpeedButton3Click(Sender: TObject);
    procedure TabSheet2Show(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListaTabelasClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure SpeedButton2Click(Sender: TObject);
    procedure Mensagem(ATitulo, AMensagem :string);
    procedure SpeedButton8Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure adCampoKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure adTipoKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure adTamanhoKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure adPrecisaoKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure adTipoExit(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure adTamanhoKeyPress(Sender: TObject; var Key: Char);
    procedure adCampoExit(Sender: TObject);
    procedure edTamanhoKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EdPrecisaoKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TabSheet1Show(Sender: TObject);
    procedure AcimaClick(Sender: TObject);
    procedure AbaixoClick(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure edLoginKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure edSenhaKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmTabelas: TfrmTabelas;
  LTipo, RTipo : string;
  Seg : boolean;

implementation

uses DataModule, Configurar_Campos, Unit1, Backup_Restore, Formulas;

{$R *.dfm}

function DelFormat(sTexto:String):String;
var
iPos : Integer;
iTamanho : Integer;
sTextoSemFormato : String;
sCaractere : String;
sCaracMascaras : String;
begin
Result := sTexto;
if sTexto = ''  then
begin
Exit;
end;
sTextoSemFormato := '';
sCaracMascaras := './><+=[]{}()-$&@* ';
iTamanho := Length(sTexto);
for iPos := 1 to iTamanho do
begin
sCaractere := Copy(sTexto,iPos,1);
if Pos(sCaractere,sCaracMascaras) = 0 then
begin
sTextoSemFormato := sTextoSemFormato + sCaractere;
end; end;
Result := sTextoSemFormato;
end;

function SemAcentos(Str:String): String;
Const ComAcento = '';
SemAcento = 'aaeouaoaeioucuAAEOUAOAEIOUCU';
var
x : Integer;
begin
For x := 1 to Length(Str) do
begin
if Pos(Str[x],ComAcento)<>0 Then
begin
Str[x] := SemAcento[Pos(Str[x],ComAcento)];
end;
end;
Result := Str;
end;

procedure TfrmTabelas.Mensagem(ATitulo, AMensagem :string);
var
Button: Integer;
Titulo : Array[0..79] of Char;
Mensagem : Array[0..200] of Char;
begin
StrPCopy(Titulo, Atitulo);
StrPCopy(Mensagem, AMensagem);
Button := Application.MessageBox (Mensagem,Titulo, MB_YESNO+mb_DefButton2+MB_ICONQUESTION);
if button = idno then
   abort;
end;

procedure TfrmTabelas.BitBtn1Click(Sender: TObject);
Var i : integer;
begin
i := ListaTabelas.ItemIndex;
Mensagem('Excluir Tabela','Excluir Tabela: [ '+Trim(ListaTabelas.Items[i])+' ]');
with dados.Query do begin
     close;
     sql.Clear;
     sql.Text := 'drop table '+Trim(ListaTabelas.Items[i]);
     ExecSql;
end;
Tabsheet2Show(self);
ListaCampos.Clear;
end;

procedure TfrmTabelas.ComboTipoExit(Sender: TObject);
begin
if comboTipo.ItemIndex in [0, 1, 3] then begin
   edtamanho.ReadOnly:=true;
   edPrecisao.ReadOnly:=true;
   end;
if comboTipo.ItemIndex in [2,4] then begin
   edtamanho.ReadOnly:=false;
   edPrecisao.ReadOnly:=true;
   end;
if comboTipo.ItemIndex in [5] then begin
   edtamanho.ReadOnly:=false;
   edPrecisao.ReadOnly:=false;
   end;
end;

procedure TfrmTabelas.ComboTipoKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = 13 then PostMessage(Handle, WM_NEXTDLGCTL, 0, 0);
end;

procedure TfrmTabelas.edCampoExit(Sender: TObject);
begin
edCampo.Text := DelFormat(SemAcentos(edCampo.Text));
end;

procedure TfrmTabelas.edCampoKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = 13 then PostMessage(Handle, WM_NEXTDLGCTL, 0, 0);
if key = 38 then PostMessage(Handle, WM_NEXTDLGCTL, 9, 0);//Seta para Cima
if key = 40 then PostMessage(Handle, WM_NEXTDLGCTL, 0, 0);//Seta para Baixo
end;

procedure TfrmTabelas.EdTabelaExit(Sender: TObject);
begin
edtabela.Text := DelFormat(SemAcentos(edtabela.Text));
end;

procedure TfrmTabelas.EdTabelaKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = 13 then PostMessage(Handle, WM_NEXTDLGCTL, 0, 0);
if key = 38 then PostMessage(Handle, WM_NEXTDLGCTL, 9, 0);//Seta para Cima
if key = 40 then PostMessage(Handle, WM_NEXTDLGCTL, 0, 0);//Seta para Baixo;
end;

procedure TfrmTabelas.edTamanhoKeyPress(Sender: TObject; var Key: Char);
begin
If not( key in['0'..'9',',',#08] ) then
begin
beep;
key:=#0;
end;
end;

procedure TfrmTabelas.FormCreate(Sender: TObject);
begin
tabsheet1.Show;
end;

procedure TfrmTabelas.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = vk_Escape then close;
end;

procedure TfrmTabelas.FormShow(Sender: TObject);
begin
tabsheet1.Show;
end;

procedure TfrmTabelas.SpeedButton1Click(Sender: TObject);
Var TP, ST : String;
begin
if edCampo.Text = '' then begin
   showmessage('Informe um Nome para o Campo');
   abort;
end;
if ComboTipo.Text = '' then begin
   showmessage('Selecione um Tipo de Campo para :'+edcampo.Text);
   abort;
end;
if (ComboTipo.ItemIndex in [2, 4]) and (EdTamanho.Text = '') then begin
      showmessage('Informe o Tamanho do Campo para :'+edcampo.Text);
      abort;
end;
ST := '';
if AnsiContainsText(lista.Items.Text,EdCampo.Text) = true then begin
   showmessage('J Contm um Campo com Este Nome, Mude o Nome do Campo');
   abort;
   end;
if obrigatorio.Checked = true then ST := ' NOT NULL';
if unico.Checked = true then ST := ST + ' UNIQUE';
case ComboTipo.ItemIndex of
0 : TP := EdCampo.Text + ' INTEGER' + ST + ',';
1 : TP := EdCampo.Text + ' DATE' + ST + ',';
2 : TP := EdCampo.Text + ' VARCHAR('+EdTamanho.Text+')' + ST + ',';
3 : TP := EdCampo.Text + ' DECIMAL(18,2)' + ST + ',';
4 : TP := EdCampo.Text + ' BLOB SUB_TYPE TEXT SEGMENT SIZE '+EdTamanho.Text + ST + ',';
5 : TP := EdCampo.Text + ' NUMERIC('+EdTamanho.Text+','+EdPrecisao.Text+')'+ ST + ',';
end;
ComboChave.Items.Add(EdCampo.Text);
if AnsiContainsText(lista.Items.Text,'CREATE TABLE') = false then
   Lista.Items.Add( 'CREATE TABLE ' + EdTabela.Text + ' (' );
Lista.Items.Add(TP);
EdCampo.Clear;
EdTabela.SetFocus;
EdTamanho.Clear;
EdPrecisao.Clear;
obrigatorio.Checked := false;
unico.Checked := false;
ComboTipo.ItemIndex := -1;
end;

procedure TfrmTabelas.SpeedButton4Click(Sender: TObject);
Var i, j : integer;
    L    : string;
begin
if combochave.Text = '' then begin
   showmessage('Selecione um Campo para Chave');
   combochave.DroppedDown:=true;
   abort;
   end;
if AnsiContainsText(lista.Items.Text,'PRIMARY KEY ('+combochave.Text+')') = true then
   begin
   showmessage('J Existe esta Chave Primria');
   abort;
   end;
lista.ItemIndex := 0;
for i := 1 to lista.Count do
begin
    j := lista.ItemIndex;
   //Procurar Clausula Unique da Primary Key e Alterar se Achar
    if AnsiContainsText(lista.Items[j], ComboChave.Text) = true then
    begin
       if AnsiContainsText(lista.Items[j],'UNIQUE') then
       begin
          L:= AnsiReplaceText(lista.Items[j],'UNIQUE','');
          lista.Items.Delete(j);
          lista.Items.Insert(j, L);
          Lista.ItemIndex := i;
       end;
    end;
    //Procurar Pimary key e Incluir Nova Primary Key
    if AnsiContainsText(lista.Items[j], 'PRIMARY KEY') = true then
    begin
       if AnsiContainsText(lista.Items[j],L) = false then
       begin
          L:= AnsiReplaceText(lista.Items[j],')',','+ComboChave.Text+')');
          lista.Items.Delete(j);
          lista.Items.Insert(j, L);
          Lista.ItemIndex := i;
       end;
    end;
lista.ItemIndex := lista.ItemIndex + 1;
    end;
if AnsiContainsText(lista.Items.Text,'PRIMARY KEY') = false then
   Lista.Items.Add('PRIMARY KEY ('+combochave.Text+')');
end;

procedure TfrmTabelas.TabSheet2Show(Sender: TObject);
begin
if dados.Base.Connected = false then begin
  showmessage('Configure uma Conexo ou Crie Primeiro uma Tabela');
  abort;
end;
listatabelas.Clear;
with dados.Query do begin
     sql.Clear;
     sql.Text := 'SELECT RDB$RELATION_NAME FROM RDB$RELATIONS'+#13+
                 'WHERE RDB$VIEW_BLR IS NULL AND (RDB$SYSTEM_FLAG = 0 OR RDB$SYSTEM_FLAG IS NULL)';
     open;
     end;
while not dados.Query.Eof do begin
      listaTabelas.Items.Add(dados.Query.Fields.Fields[0].value);
      dados.Query.Next;
end;
ListaTabelas.Enabled := true;
PainelOpcao.Visible:=false;
end;

procedure TfrmTabelas.ListaKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = vk_delete then lista.DeleteSelected;
end;

procedure TfrmTabelas.ListaTabelasClick(Sender: TObject);
Var i : integer;
begin
try
i := ListaTabelas.ItemIndex;
with dados.IBTable do begin
     close;
     sql.Clear;
     sql.Text := 'select * from '+ ListaTabelas.Items[i];
     open;
     end;
dados.IBTable.GetFieldNames(Listacampos.Items);
except
end;
end;

procedure TfrmTabelas.SpeedButton3Click(Sender: TObject);
Var i, j : integer;
    TX : string;
begin
if seg = false then begin
j := lista.Count -1;
if AnsiContainsText(lista.Items[j],',') then begin
   Tx := AnsiReplaceText(lista.Items[j],',','');
   Lista.Items.Delete(j);
   Lista.Items.Insert(j, Tx);
end;end;

if not AnsiContainsText(lista.Items.Text,');') then
if not AnsiContainsText(lista.Items.Text,');') then
   lista.Items.Add(');');

//Testa se Base de Dados existe caso nao Cria
if dados.Base.Connected = false then begin
  if not FileExists(Diretorio+'BD\Base.fdb') = true then
  begin
   Dados.CreateDataBase(Diretorio+'BD\Base.fdb');
   with IBBackup do begin
        try
        try
        Attach;
        Databasename := Diretorio+'BD\Base.fdb';
        BackupFile.Add(Diretorio+'BD\Base.fbk');
        Active:=true;
        ServiceStart;
        Except
        on E : exception do showmessage('Erro: '+e.Message);
        end;
        finally
        IBBackup.Free;
        end;
   end;
   sleep(200);
   with IBRestore do begin
        try
        try
        Attach;
        Databasename.Add(Diretorio+'BD\Base.fdb');
        BackupFile.Add(Diretorio+'BD\Base.fbk');
        Active:=true;
        ServiceStart;
        Except
        on E : exception do showmessage('Erro: '+e.Message);
        end;
        finally
        IBRestore.Free;
        end;
   end;
   try
   Config := Tinifile.Create(Diretorio+'Config.dat');
   Config.WriteString('BASE','REDE','NAO');
   Config.WriteString('BASE','IP','localhost');
   Config.WriteString('BASE','TABELA',Diretorio+'BD\Base.fdb');
   TCP := 'localhost';
   Conexao :=Diretorio+'BD\Base.fdb';
   finally
   Config.Free;
   end;
end;
sleep(200);
//Conecta Base de Dados Criada
dados.Base.DatabaseName := TCP + ':' + Conexao;
end;
dados.Base.Open;
//Caso conexo Exista Cria Tabela;
if Dados.Base.Connected = true then
   Dados.CreateTabela(lista.Items.Text)//Criando Tabela
   else showmessage('Falha na Conexo com o Banco');
dados.Destroy;
Application.CreateForm(TDados,Dados);
dados.Base.Close;
dados.Base.DatabaseName := TCP + ':' + Conexao;
dados.Base.Open;
lista.Clear;
EdTabela.Clear;
ComboChave.Clear;
EdCampo.Clear;
EdTamanho.Clear;
EdPrecisao.Clear;
obrigatorio.Checked := false;
unico.Checked := false;
ComboTipo.ItemIndex := -1;
end;

procedure TfrmTabelas.SpeedButton2Click(Sender: TObject);
Var i, j : integer;
begin
i := ListaTabelas.ItemIndex;
j := ListaCampos.ItemIndex;
Mensagem('Excluir Campo','Excluir Campo: [ '+Trim(ListaCampos.Items[j])+' ]');
with dados.Query do begin
     close;
     sql.Clear;
     sql.Text := 'ALTER TABLE '+Trim(listaTabelas.Items[i])+' DROP '+Trim(ListaCampos.Items[j]);
     ExecSql;
end;
ListaTabelasClick(self);
end;

procedure TfrmTabelas.SpeedButton8Click(Sender: TObject);
begin
painelopcao.Visible:=false;
ListaTabelas.Enabled := true;
PainelOrdem.Visible := true;
end;

procedure TfrmTabelas.SpeedButton6Click(Sender: TObject);
begin
ListaTabelas.Enabled := false;
PainelOrdem.Visible := false;
AdCampo.Clear;
AdTipo.ItemIndex := -1;
adNull.Checked := false;
adUnique.Checked := false;
AdTamanho.Clear;
AdPrecisao.Clear;
PainelOpcao.Visible:=true;
Tela.ActivePage := 'AD';
AdCampo.SetFocus;
end;

procedure TfrmTabelas.adCampoKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = 13 then PostMessage(Handle, WM_NEXTDLGCTL, 0, 0);
if key = 38 then PostMessage(Handle, WM_NEXTDLGCTL, 9, 0);
if key = 40 then PostMessage(Handle, WM_NEXTDLGCTL, 0, 0);
end;

procedure TfrmTabelas.adTipoKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = 13 then PostMessage(Handle, WM_NEXTDLGCTL, 0, 0);
end;

procedure TfrmTabelas.adTamanhoKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = 13 then PostMessage(Handle, WM_NEXTDLGCTL, 0, 0);
if key = 38 then PostMessage(Handle, WM_NEXTDLGCTL, 9, 0);
if key = 40 then PostMessage(Handle, WM_NEXTDLGCTL, 0, 0);
end;

procedure TfrmTabelas.adPrecisaoKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = 13 then PostMessage(Handle, WM_NEXTDLGCTL, 0, 0);
if key = 38 then PostMessage(Handle, WM_NEXTDLGCTL, 9, 0);
if key = 40 then PostMessage(Handle, WM_NEXTDLGCTL, 0, 0);
end;

procedure TfrmTabelas.adTipoExit(Sender: TObject);
begin
if adTipo.ItemIndex in [0, 1, 3] then begin
   adtamanho.ReadOnly:=true;
   adPrecisao.ReadOnly:=true;
   end;
if adTipo.ItemIndex in [2,4] then begin
   adtamanho.ReadOnly:=false;
   adPrecisao.ReadOnly:=true;
   end;
if adTipo.ItemIndex in [5] then begin
   adtamanho.ReadOnly:=false;
   adPrecisao.ReadOnly:=false;
   end;
end;

procedure TfrmTabelas.SpeedButton7Click(Sender: TObject);
Var i : integer;
begin
if (adCampo.Text = '') or (adTipo.Text = '') then begin
   showmessage('Preencha os Campos Obrigatrios');
   abort;
   end;
if adTipo.ItemIndex in [2,4,5] then
   if adTamanho.Text = '' then begin
      showmessage('Informe o Tamanho do Campo');
      abort;
      end;
if adTipo.ItemIndex in [5] then begin
   if adPrecisao.Text = '' then begin
      showmessage('Informe o Preciso do Campo');
      abort;
      end;
   if strtoint(adTamanho.Text) > 18 then begin
     showmessage('Tamanho Mximo Permitido  18');
     abort;
     end;
   if strtoint(adTamanho.Text) > 3 then begin
     showmessage('Preciso Mxima Permitida  3');
     abort;
     end;
end;
Case adTipo.ItemIndex of
0: LTipo := 'INTEGER';
1: LTipo := 'DATE';
2: LTipo := 'VARCHAR('+adTamanho.Text+')' ;
3: LTipo := 'DECIMAL(18,2)';
4: LTipo := 'BLOB SUB TYPE TEXT SEGMENT SIZE';
5: LTipo := 'NUMERIC('+adTamanho.Text+','+adPrecisao.Text+')';
end;
i := ListaTabelas.ItemIndex;
try
if adNull.Checked = true then LTipo := LTipo + ' NOT NULL';
if adUnique.Checked = true then LTipo := LTipo + ' UNIQUE';
with dados.Query do begin
     close;
     sql.Clear;
     sql.Text := 'ALTER TABLE '+Trim(ListaTabelas.Items[i])+' ADD "'+adCampo.Text+'" '+LTipo+';';
     ExecSql;
     end;
Showmessage('Campo Incluso com Sucesso');
AdCampo.Clear;
AdTipo.ItemIndex := -1;
AdTamanho.Clear;
AdPrecisao.Clear;
AdCampo.SetFocus;
adNull.Checked := false;
adUnique.Checked := false;
Except
on E : exception do
   showmessage('Erro ao Incluir Campo. Erro: '+E.Message);
end;
ListaTabelasclick(self);
end;

procedure TfrmTabelas.adTamanhoKeyPress(Sender: TObject; var Key: Char);
begin
If not( key in['0'..'9',',',#08] ) then
begin
beep;
key:=#0;
end;
end;

procedure TfrmTabelas.adCampoExit(Sender: TObject);
begin
AdCampo.Text := DelFormat(SemAcentos(AdCampo.Text));
end;

procedure TfrmTabelas.edTamanhoKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = 13 then PostMessage(Handle, WM_NEXTDLGCTL, 0, 0);//Seta para Cima
if key = 38 then PostMessage(Handle, WM_NEXTDLGCTL, 9, 0);//Seta para Cima
if key = 40 then PostMessage(Handle, WM_NEXTDLGCTL, 0, 0);//Seta para Baixo
end;

procedure TfrmTabelas.EdPrecisaoKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = 13 then PostMessage(Handle, WM_NEXTDLGCTL, 9, 0);//Seta para Cima
if key = 38 then PostMessage(Handle, WM_NEXTDLGCTL, 9, 0);//Seta para Cima
if key = 40 then PostMessage(Handle, WM_NEXTDLGCTL, 0, 0);//Seta para Baixo
end;

procedure TfrmTabelas.TabSheet1Show(Sender: TObject);
begin
edTabela.SetFocus;
end;

procedure TfrmTabelas.AcimaClick(Sender: TObject);
Var i, j : integer; S: String;
begin
i := ListaCampos.ItemIndex;
j := ListaTabelas.ItemIndex;
if (ListaCampos.Items[i] = '') or (ListaTabelas.Items[j] = '') then abort;
S := ListaCampos.Items[i];
ListaCampos.Items.Move(i, i - 1);
Try
with dados.Query do begin
     close;
     sql.Clear;
     sql.Text :='Alter table '+Trim(ListaTabelas.Items[j])+
                ' Alter Column '+ S + ' Position '+ inttostr(i)+';';
     ExecSql;
     end;
Except
on E : Exception do
   showmessage('Erro: '+E.Message);
   end;
end;

procedure TfrmTabelas.AbaixoClick(Sender: TObject);
Var i, j : integer; S: String;
begin
i := ListaCampos.ItemIndex;
j := ListaTabelas.ItemIndex;
if (ListaCampos.Items[i] = '') or (ListaTabelas.Items[j] = '') then abort;
S := ListaCampos.Items[i];
ListaCampos.Items.Move(i, i + 1);
Try
with dados.Query do begin
     close;
     sql.Clear;
     sql.Text :='Alter table '+Trim(ListaTabelas.Items[j])+
                ' Alter Column '+ S + ' Position '+ inttostr(i + 2)+';';
     ExecSql;
     end;
Except
on E : Exception do
   showmessage('Erro: '+E.Message);
   end;
end;

procedure TfrmTabelas.SpeedButton5Click(Sender: TObject);
Var SS, QR : String;
begin
seg := true;
SS := Lista.Items.Text;
Lista.Clear;
Lista.Items.Add('Create Table USERSYS ('+#13+
                'LOGIN VARCHAR(15) NOT NULL, '+#13+
                'SENHA VARCHAR(10) NOT NULL, '+#13+
                'PROTEGER VARCHAR(1), '+#13+
                'PRIMARY KEY(LOGIN)');
try
speedbutton3.Click;
sleep(1000);
finally
Lista.Clear;
Lista.Items.Add(SS);
try
with dados.Query do begin
     close;
     sql.Clear;
     QR := 'insert into USERSYS (LOGIN, SENHA, PROTEGER) VALUES (';
     if checkbox1.Checked = true then
        QR := QR + QuotedStr(edlogin.Text)+','+QuotedStr(edsenha.Text)+', ''S'')' else
        QR := QR + QuotedStr(edlogin.Text)+','+QuotedStr(edsenha.Text)+', ''N'')';
     sql.Text := QR;
     ExecSql;
     end;
     Showmessage('Proteo Criada Com Sucesso');
Except
On E : Exception do
   showmessage('Erro : '+E.Message);
   end;
end;
seg := false;
end;

procedure TfrmTabelas.edLoginKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = 13 then edsenha.SetFocus;
end;

procedure TfrmTabelas.edSenhaKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = 13 then speedbutton5.Click;
end;

procedure TfrmTabelas.CheckBox1Click(Sender: TObject);
begin
edlogin.SetFocus;
end;

end.
