unit Tela_Cadastro;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, DB, Mask, DBCtrls, ExtCtrls, ComCtrls,
  ActnList;

type
  TFormCad = class(TForm)
    Nave: TDBNavigator;
    StatusBar1: TStatusBar;
    ActionList1: TActionList;
    Foco: TAction;
  procedure CriarLabel(const X :integer; Y :integer; Nome : string; D : TDataSource; F : string);
  procedure CriarDBMemo(const x :integer; Y:integer; Nome : string; D:TDataSource; F : string);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FocoExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormCad: TFormCad;
  LSender: string;

implementation

uses Formulario, DataModule;

{$R *.dfm}

procedure TFormCad.CriarDBMemo(const X :integer; Y :integer; Nome : string; D : TDataSource; F : string);
var
    M:Tdbmemo;
    L:Tlabel;
begin
  M:=Tdbmemo.Create(self);
  L:=TLabel.Create(self);
  M.Visible:=false;
  L.Visible:=false;
  M.Parent:=self;
  L.Parent:=self;
  M.Left:=X + 100;
  L.Left:=X;
  M.Width :=300;
  M.Height:=150;
  M.Top := Y;
  L.Top := Y;
  L.Caption := Nome+':';
  L.Name := nome;
  M.name:='M'+nome;
  l.Visible:=true;
  M.DataField := nome;
  M.DataSource := D;
  M.Visible:=true;
end;

procedure TFormCad.CriarLabel(const X :integer; Y :integer; Nome : string; D : TDataSource; F : string);
var L:tlabel;
    E:Tdbedit;
begin
  L:=Tlabel.Create(self);
  E:=Tdbedit.Create(self);
  L.visible:=false;
  E.Visible:=false;
  L.parent:=self;
  E.Parent:=self;
  L.left:=X;
  E.Left:=X+100;
  L.top:=Y;
  E.Top:=Y;
  L.Width :=100;
  E.Width:=300;
  L.name:=nome;
  E.Name:='db'+nome;
  L.Caption:=Nome + ':';
  E.DataField := F ;
  E.DataSource := D;
  L.visible:=true;
  E.Visible:=true;
end;

procedure TFormCad.FormShow(Sender: TObject);
begin
FormCad.Height := tamanho + MEM;
end;

procedure TFormCad.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
Var x : integer;
begin
if key = vk_escape then close;
if key = vk_insert then begin
   nave.BtnClick(nbinsert);
   foco.Execute;
   end;
if key = vk_F2 then if nave.DataSource.DataSet.State in [dsinsert,dsedit] then nave.BtnClick(nbpost);
if key = vk_f3 then nave.BtnClick(nbcancel);
if key = vk_f4 then nave.BtnClick(nbdelete);

if Key = 13 then begin
  for x:=0 to ComponentCount-1 do
    if (Components[x] is TWinControl) and
       (Components[x] as TWinControl).Focused  and
       (Components[x] is TDBMemo) then abort;
   Key := 0;
   PostMessage(Handle, WM_NEXTDLGCTL, 0, 0);
   end;
if key = VK_UP then begin
   for x:=0 to ComponentCount-1 do
    if (Components[x] is TWinControl) and
       (Components[x] as TWinControl).Focused  and
       (Components[x] is TDBMemo) then abort;
       PostMessage(Handle, WM_NEXTDLGCTL, 9, 0)
end;
if Key = VK_DOWN then begin
    for x:=0 to ComponentCount-1 do
    if (Components[x] is TWinControl) and
       (Components[x] as TWinControl).Focused  and
       (Components[x] is TDBMemo) then abort;
       PostMessage(Handle, WM_NEXTDLGCTL, 0, 0);
end;
if key = vk_next then begin
   if Nave.DataSource.DataSet.State in [dsedit,dsinsert] then
   else Nave.DataSource.DataSet.Next;
   end;
if key = vk_prior then begin
   if Nave.DataSource.DataSet.State in [dsedit,dsinsert] then
   else Nave.DataSource.DataSet.Prior;
   end;
end;

procedure TFormCad.FormKeyPress(Sender: TObject; var Key: Char);
begin
Key := AnsiUpperCase(Key)[Length(Key)];
end;

procedure TFormCad.FormClose(Sender: TObject; var Action: TCloseAction);
begin
try
frmForm.DBNavigator1.BtnClick(nbrefresh);
except
FormCad.Close;
end;
end;

procedure TFormCad.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
if frmForm.DS.DataSet.State in [dsinsert, dsedit] then begin
   showmessage('Registro em Modo de Insero ou Edio'+#13+
               'Grave ou Cancele Antes de Sair!');
   canclose:=false;
end;end;

procedure TFormCad.FocoExecute(Sender: TObject);
Var x : integer;
begin
   try
   for x := 0 to componentcount-1 do
     if components[x].GetNamePath = 'db'+lsender then begin
        sender := Components[x];
        Tdbedit(sender).SetFocus;
        end;
   except
   for x := 0 to componentcount-1 do
   if components[x].GetNamePath = 'M'+lsender then begin
      sender := Components[x];
      TdbMemo(sender).SetFocus;
      end;
   end;  
end;

end.
