unit Formulario;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, DB, Grids, DBGrids, DBCtrls, Buttons,IBCustomDataSet,
  ComCtrls, ClipBrd, shellapi, Menus, DBClient,ActnList, DateUtils, StrUtils;

type
  TfrmForm = class(TForm)
    Panel1: TPanel;
    DBNavigator1: TDBNavigator;
    DBGrid1: TDBGrid;
    DS: TDataSource;
    GroupBox1: TGroupBox;
    Tabela: TComboBox;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Campo: TComboBox;
    Comboopcao: TComboBox;
    Filtro1: TEdit;
    Label2: TLabel;
    Filtro2: TEdit;
    SpeedButton1: TSpeedButton;
    BtFiltro: TSpeedButton;
    btCad: TSpeedButton;
    StatusBar1: TStatusBar;
    btCalc: TSpeedButton;
    SpeedButton3: TSpeedButton;
    Popup: TPopupMenu;
    Imprimir1: TMenuItem;
    CopiarparareadeTransferncia1: TMenuItem;
    ExportarparaExcel1: TMenuItem;
    ExportarparaWord1: TMenuItem;
    ExportarparaTXT1: TMenuItem;
    ListaCampos: TListBox;
    LFiltro: TListBox;
    btE: TSpeedButton;
    SpeedButton5: TSpeedButton;
    ActionList1: TActionList;
    Calcula: TAction;
    GroupBox3: TGroupBox;
    Label3: TLabel;
    OrdCampos: TComboBox;
    btOrdenar: TSpeedButton;
    Edit1: TEdit;
    Modificar: TAction;
    Inserir: TAction;
    Atualizar: TAction;
    Deletar: TAction;
    procedure TabelaChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DBGrid1KeyPress(Sender: TObject; var Key: Char);
    procedure SpeedButton1Click(Sender: TObject);
    procedure ComboopcaoChange(Sender: TObject);
    procedure CampoKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CampoCloseUp(Sender: TObject);
    procedure CampoExit(Sender: TObject);
    procedure ComboopcaoExit(Sender: TObject);
    procedure BtFiltroClick(Sender: TObject);
    procedure ComboopcaoKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Filtro1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Filtro2KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btCadClick(Sender: TObject);
    procedure DSUpdateData(Sender: TObject);
    procedure btCalcClick(Sender: TObject);
    procedure DSDataChange(Sender: TObject; Field: TField);
    procedure SpeedButton3Click(Sender: TObject);
    procedure CopyGrid(DBGrid: TDBGrid; PastHeader: Boolean);
    procedure Imprimir1Click(Sender: TObject);
    procedure CopiarparareadeTransferncia1Click(Sender: TObject);
    procedure ExportarparaExcel1Click(Sender: TObject);
    procedure ExportarparaWord1Click(Sender: TObject);
    procedure ExportarparaTXT1Click(Sender: TObject);
    procedure btEClick(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure CalculaExecute(Sender: TObject);
    procedure DBGrid1TitleClick(Column: TColumn);
    procedure DSStateChange(Sender: TObject);
    procedure DBGrid1DblClick(Sender: TObject);
    procedure ComboopcaoCloseUp(Sender: TObject);
    procedure btOrdenarClick(Sender: TObject);
    procedure OrdCamposCloseUp(Sender: TObject);
    procedure AjustaColunas(DBGrid: TDBGrid);
    procedure ModificarExecute(Sender: TObject);
    procedure InserirExecute(Sender: TObject);
    procedure DeletarExecute(Sender: TObject);
    procedure AtualizarExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmForm: TfrmForm;
  UpSql, OP, Filtro, Cmp, Ccpf, Icampo, DCampo, IBCampo : string;
  Tamanho, Mem : integer;
  Calc, DTD, Valida, Yes, Inc : boolean;
  OldColumn : TColumn;

implementation

uses DataModule, Configurar_Campos, Unit1, Inifiles, Criar_Tabelas,
  Tela_Cadastro, Formulas;

{$R *.dfm}

procedure TfrmForm.CopyGrid(DBGrid: TDBGrid; PastHeader: Boolean);
var
  StrToCopy: string;
  Idx, IdxCol: Integer;
  BookMark, SavedBookMark: TBookMark;
begin
  if DBGrid.SelectedRows.Count = 0 then
    Exit;
  StrToCopy := '';
 if yes = true then begin
  if PastHeader then
  begin
    StrToCopy := DBGrid.Columns[0].Title.Caption;
    for IdxCol := 1 to DBGrid.Columns.Count - 1 do
      StrToCopy := format('%s'#9'%s', [StrToCopy,
        DBGrid.Columns[IdxCol].Title.Caption]);
    StrToCopy := StrToCopy +#13#10;
  end;
 end;
  with DBGrid.DataSource.DataSet do
  begin
    //salva a posio atual no DBGrid
    SavedBookMark := GetBookmark;
    //evita movimentao no DBGrid
    DisableControls;
    for Idx := 0 to DBGrid.SelectedRows.Count - 1 do
    begin
      //posiciona na linha selecionada
      GotoBookMark(Pointer(DBGrid.SelectedRows[Idx]));
      StrToCopy := StrToCopy + DBGrid.Columns[0].Field.AsString;
      for IdxCol := 1 to DBGrid.Columns.Count - 1 do
        StrToCopy := Format('%s'#9'%s', [StrToCopy,
          DBGrid.Columns[IdxCol].Field.AsString]);
      StrToCopy := StrToCopy + #13#10;
    end;
    ClipBoard.Clear;
    ClipBoard.SetTextBuf(PChar(StrToCopy));
    //Restauramos o posicionamento inicial do DBGrid
    GotoBookMark(SavedBookMark);
    FreeBookMark(SavedBookMark);
    //reabilitamos movimentao no DBGrid
    EnableControls;
  end;
end;

procedure TfrmForm.AjustaColunas(DBGrid: TDBGrid);
var
  i, j: integer;
  TotWidth : integer;
  VarWidth : integer;
begin
  TotWidth := 0;
  VarWidth := 0;
  dados.TABELA.DisableControls;
  for i := 0 to -1 + DBGrid.Columns.Count do
  begin
  dados.TABELA.First;
    for j := 0 to dados.TABELA.RecordCount do
      begin
        TotWidth := Canvas.TextWidth(DBGrid.Columns[i].Field.Text);
          if TotWidth > VarWidth then
             DBGrid.Columns[i].Width := 8 + TotWidth;
          if VarWidth < TotWidth then
             VarWidth := TotWidth;
        dados.TABELA.Next;
      end;
  end;
  dados.TABELA.First;
  dados.TABELA.EnableControls;
end;

procedure TfrmForm.TabelaChange(Sender: TObject);
Var i : integer;
begin
Campo.Clear;
btordenar.Click;
dados.TABELA.IndexFieldNames:='';
Inc := False;
filtro:='';
LFiltro.Clear;
Listacampos.Clear;
DTD := FALSE;
Statusbar1.Panels[1].Text:='';
if Valida = true then Valida := false;
if Calc = true then begin
   Calc := false;
   Statusbar1.Panels[0].Text:='';
   end;
dados.TABELA.CommandText:='';
filtro1.Clear;
filtro2.Clear;
with dados.IBTable do begin
     Close;
     sql.Clear;
     sql.Text := 'select * from '+TRIM(tabela.Text);
     open;
     end;
dados.TABELA.Close;
dados.TABELA.Open;
dados.TABELA.GetFieldNames(campo.items);
dados.TABELA.GetFieldNames(Ordcampos.items);
//Pegar Configuraes
if FileExists(Diretorio+'Config.dat') then begin
   Try
   Config := Tinifile.Create(Diretorio+'Config.dat');
   Campo.ItemIndex := 0;
   for i := 1 to campo.Items.Count do
   begin
     //Configurar Campo Data
     if frmConfigurar.tipocampo(dados.TABELA.FieldByName(campo.Text).DataType) = 'DATA' then
        TIBBCDFIELD(dados.Tabela.FieldByName(campo.Text)).EditMask := '00/00/0000';
     if Config.ReadString(trim(tabela.Text),trim(campo.Text),'') <> '' then begin
        //Configurar Campo Monetrio
        if frmConfigurar.tipocampo(dados.TABELA.FieldByName(campo.Text).DataType) = 'VALOR' then
           TIBBCDFIELD(dados.Tabela.FieldByName(campo.Text)).currency := true
           else//Configurar Campos Diversos
           TIBBCDFIELD(dados.Tabela.FieldByName(campo.Text)).EditMask := Config.ReadString(tabela.Text,campo.Text,'');
     end;
     if Config.ReadString(tabela.Text,'F'+campo.Text,'') = 'CALCULAR' then begin
        Calc := true;
//        cmp := campo.Text;
        listacampos.Items.Add(campo.Text);
        end;
     if Config.ReadString(tabela.Text,'F'+campo.Text,'') = 'VALIDAR CPF E CNPJ' then begin
        Valida := true;
        Ccpf := campo.Text;
        end;
     if Config.ReadString(trim(tabela.Text),'F'+campo.Text,'') = 'AUTO NUMERVEL' then begin
        Inc := true;
        ICampo := campo.Text;
        end;
     if Config.ReadString(trim(tabela.Text),'F'+campo.Text,'') = 'DATA DO DIA' then begin
        DTD := true;
        DCampo := campo.Text;
        end;
        campo.ItemIndex := campo.ItemIndex + 1;
   end;
   finally
   Config.Free;
   end;
end;
dados.TABELA.Refresh;
campo.ItemIndex := -1;
if Calc = true then calcula.Execute;
dbgrid1.SetFocus;
AjustaColunas(dbgrid1);
{Modificar.Execute;
inserir.Execute;
deletar.Execute;
Atualizar.Execute;}
end;

procedure TfrmForm.FormShow(Sender: TObject);
begin
if form1.WindowState = WsMaximized then begin
frmForm.Width  := form1.Width - 10;
frmForm.Height := form1.Height - 95;
end;
if dados.Base.Connected = false then dados.Base.Open;
with dados.Query do begin
     sql.Clear;
     sql.Text := 'SELECT RDB$RELATION_NAME FROM RDB$RELATIONS'+#13+
                 'WHERE RDB$VIEW_BLR IS NULL AND (RDB$SYSTEM_FLAG = 0 OR RDB$SYSTEM_FLAG IS NULL)';
     open;
     end;
while not dados.Query.Eof do begin
      tabela.Items.Add(dados.Query.Fields.Fields[0].value);
      dados.Query.Next;
end;end;

procedure TfrmForm.FormCreate(Sender: TObject);
begin
if dados.Base.Connected = false then
   dados.Base.Open;
dados.TABELA.Close;
end;

procedure TfrmForm.DBGrid1KeyPress(Sender: TObject; var Key: Char);
begin
Key := AnsiUpperCase(Key)[Length(Key)];
end;

procedure TfrmForm.DBGrid1TitleClick(Column: TColumn);
begin
{if dados.TABELA.Active = false then abort;
try
if Assigned(OldColumn) then
   OldColumn.Title.Color := clInfoBK;
except
end;
dados.TABELA.IndexFieldNames := column.FieldName;
Column.Title.Color := clSilver;
OldColumn := Column;}
end;

procedure TfrmForm.SpeedButton1Click(Sender: TObject);
begin
if tabela.Text = '' then begin
   showmessage('selecione uma Tabela Primeiro');
   abort;
end;
try
  frmConfigurar:=TfrmConfigurar.Create(self);
  frmConfigurar.LTabela.Caption := Tabela.Text;
  frmConfigurar.ShowModal;
finally
  frmConfigurar.Release;
  TabelaChange(self);
end;
end;

procedure TfrmForm.ComboopcaoChange(Sender: TObject);
begin
case comboopcao.ItemIndex of
0 : OP := '=' ;
1 : OP := '<>';
2 : OP := '>=';
3 : OP := '<=';
4 : OP := 'BETWEEN';
5 : OP := 'LIKE';
end;
end;

procedure TfrmForm.CampoKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = 13 then comboopcao.SetFocus;
end;

procedure TfrmForm.CalculaExecute(Sender: TObject);
Var i : integer;
begin
Statusbar1.Panels[1].Text:='';
   for i := 0 to Listacampos.Count - 1 do begin
//      listcalculos.Items.Add(calcular(listacampos.Items[i],ds));
   StatusBar1.Panels[1].Text:= trim(StatusBar1.Panels[1].Text) +'   '+
                               listacampos.Items[i] + ' ' + Calcular(listacampos.Items[i],ds)+ ' '
   end;
end;

procedure TfrmForm.CampoCloseUp(Sender: TObject);
begin
comboopcao.SetFocus;
end;

procedure TfrmForm.CampoExit(Sender: TObject);
begin
comboopcao.SetFocus;
end;

procedure TfrmForm.ComboopcaoExit(Sender: TObject);
begin
if comboopcao.ItemIndex in [0,1,2,3,5] then
   filtro2.ReadOnly:=true;
if comboopcao.ItemIndex in [4] then
   filtro2.ReadOnly:=false;
   ComboOpcaochange(self);
end;

procedure TfrmForm.BtFiltroClick(Sender: TObject);
begin
if tabela.Text = '' then abort;
try
dados.TABELA.CommandText := filtro;
dados.TABELA.Execute;
except
dados.TABELA.Refresh;
end;
if Calc = true then Calcula.execute;
end;

procedure TfrmForm.ComboopcaoKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = 13 then filtro1.SetFocus;
end;

procedure TfrmForm.Filtro1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = VK_UP then PostMessage(Handle, WM_NEXTDLGCTL, 9, 0)
   else
if Key = VK_DOWN then PostMessage(Handle, WM_NEXTDLGCTL, 0, 0);
if key = 13 then filtro2.SetFocus;
end;

procedure TfrmForm.Filtro2KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = VK_UP then PostMessage(Handle, WM_NEXTDLGCTL, 9, 0)
   else
if Key = VK_DOWN then PostMessage(Handle, WM_NEXTDLGCTL, 0, 0);
if key = 13 then BtE.Click;
end;

procedure TfrmForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
Var ST : String;
    i  : integer;
    Bok : boolean;
    campos:string;
begin
if key = vk_escape then close;
if key = vk_insert then btCad.Click;

if key = vk_f1 then if tabela.Text <> '' then
begin
   Campos := Dbgrid1.SelectedField.FieldName;
   ST := '';
   Bok := inputquery('Localizar', 'Digite Aqui sua Busca por: [ '+Campos+' ]', ST);
   if st = '' then st := '0';
      if bok then
      if not ds.DataSet.Locate(Campos, uppercase(st),[loCaseInsensitive,lopartialkey]) then showmessage('[ '+campos+' ]'+' " '+ST+' " No Localizado')
      else
      ds.DataSet.Locate(Campos, uppercase(st),[loCaseInsensitive,lopartialkey]);
end;
if key = vk_f4 then begin
   st := '';
   deletar.Execute;
   Mensagem('Deseja Excluir este Registro: ',IbCampo);
   st := AnsiReplaceText(edit1.Text,';',',');
   with dados.Query do begin
        close;
        sql.Clear;
        if edit1.Text <> '' then
        sql.Text := 'delete from '+trim(tabela.Text)+' order by '+st+' rows('+inttostr(dados.TABELA.RecNo)+') to '+inttostr(dados.TABELA.RecNo)
        else         sql.Text := 'delete from '+trim(tabela.Text)+' rows('+inttostr(dados.TABELA.RecNo)+') to '+inttostr(dados.TABELA.RecNo);

        execSql;
        end;
   dados.IBTable.Close;
   dados.IBTable.Open;
   dados.TABELA.Refresh;
   if dados.IBTransaction1.InTransaction then
      dados.ibtransaction1.Commit;
   campo.ItemIndex := -1;
   end;

end;

procedure TfrmForm.btCadClick(Sender: TObject);
Var i, j : integer;
    tt : boolean;
begin
if tabela.Text = '' then begin
   showmessage('Selecione uma Tabela Primeiro');
   abort;
end;
try
LSender := '';
tt := false;
formCad:=TformCad.Create(self);
formCad.Nave.DataSource:=ds;
campo.ItemIndex := 0;
j := 55;
Mem := 0;
for i := 1 to campo.Items.Count do begin
    if frmConfigurar.TipoCampo(dados.TABELA.FieldByName(trim(campo.Text)).DataType) = 'MEMORANDO' then begin
       FormCad.CriarDBMemo(10 , j ,trim(campo.Text), ds , trim(campo.text));
       if LSender = '' then LSender := trim(campo.Text);
       mem := 132;
       j := j + 160;
       Tamanho := j - 100;
       tt := true;
       end else begin
       if LSender = '' then LSender := trim(campo.Text);
       FormCad.CriarLabel(10 , j , trim(campo.Text), ds , trim(campo.text));
       j := j + 30;
       if tt = false then
       Tamanho := j + 30 else Tamanho := J - 100;
       end;
    campo.ItemIndex := campo.ItemIndex + 1;
end;

campo.ItemIndex := -1;
formCad.ShowModal;
finally
FormCad.Release;
end;end;

procedure TfrmForm.DSUpdateData(Sender: TObject);
Var i : integer;
begin
Statusbar1.Panels[1].Text:='';
   for i := 0 to Listacampos.Count - 1 do begin
//      listcalculos.Items.Add(calcular(listacampos.Items[i],ds));
   StatusBar1.Panels[1].Text:= trim(StatusBar1.Panels[1].Text) +'   '+
                               listacampos.Items[i] + ' ' + Calcular(listacampos.Items[i],ds)+ ' '
   end;
end;

procedure TfrmForm.ExportarparaExcel1Click(Sender: TObject);
begin
Exportar(ds.DataSet, trim(tabela.Text), Diretorio+'Relatorios\'+trim(tabela.Text), 'xls');
end;

procedure TfrmForm.ExportarparaTXT1Click(Sender: TObject);
begin
try
ExpTXT(ds.DataSet,Diretorio + 'Relatorios\'+trim(tabela.Text)+'.txt');
finally
ShellExecute(0, 'open', pchar(diretorio+'Relatorios\'+trim(tabela.Text)+'.txt'), nil, nil, SW_SHOW);
end;
//Exportar(ds.DataSet, trim(tabela.Text), Diretorio+'Relatorios\'+trim(tabela.Text), 'txt');
end;

procedure TfrmForm.ExportarparaWord1Click(Sender: TObject);
begin
Exportar(ds.DataSet, trim(tabela.Text), Diretorio+'Relatorios\'+trim(tabela.Text), 'doc');
end;

procedure TfrmForm.btCalcClick(Sender: TObject);
begin
winexec('Calc.exe',0);
end;

procedure TfrmForm.DSDataChange(Sender: TObject; Field: TField);
begin
//Contar Registros
if ds.DataSet.State in [dsinsert,dsedit] then else
   statusbar1.Panels[0].Text := 'Registros: '+inttostr(dados.TABELA.RecordCount);
//Validar CNPJ / CPF
if Valida = true then begin
if ds.DataSet.State in [dsinsert,dsedit] then
   if ds.DataSet.FieldByName(ccpf).AsString <> '' then
      CPFCNPJ(ds.DataSet.fieldbyname(ccpf).AsString);
end;


end;


procedure TfrmForm.SpeedButton3Click(Sender: TObject);
begin
if tabela.Text = '' then begin
   showmessage('Selecione Primeiro uma Tabela');
   abort;
end;
popup.Popup(speedbutton3.ClientOrigin.X,speedbutton3.ClientOrigin.Y+41);
end;

procedure TfrmForm.Imprimir1Click(Sender: TObject);
begin
Exportar(ds.DataSet, trim(tabela.Text), Diretorio+'Relatorios\'+trim(tabela.Text), 'html');
end;

procedure TfrmForm.CopiarparareadeTransferncia1Click(Sender: TObject);
begin
Yes := true;
DBGrid1.SelectedRows.Clear;
  DBGrid1.DataSource.DataSet.DisableControls;
  try
    DBGrid1.DataSource.DataSet.First;
    while not DBGrid1.DataSource.DataSet.EOF do
    begin
      DBGrid1.SelectedRows.CurrentRowSelected := True;
      DBGrid1.DataSource.DataSet.Next;
    end;
  finally
    DBGrid1.DataSource.DataSet.EnableControls;
  end;
CopyGrid(dbgrid1,true);
end;

procedure TfrmForm.btEClick(Sender: TObject);
Var Ft1, Ft2 : string;
begin
if tabela.Text = '' then abort;
if filtro1.Text = '' then abort;
if frmconfigurar.TipoCampo(dados.TABELA.fieldbyname(trim(campo.text)).DataType) = 'DATA' then begin
   Ft1 := inttostr(MonthOf(strtodate(filtro1.Text)))+
            '/'+inttostr(DayOf(strtodate(filtro1.Text)))+
            '/'+inttostr(YearOf(strtodate(filtro1.Text)));
   if filtro2.Text <> '' then
   Ft2 := inttostr(MonthOf(strtodate(filtro2.Text)))+
            '/'+inttostr(DayOf(strtodate(filtro2.Text)))+
            '/'+inttostr(YearOf(strtodate(filtro2.Text)))
   end else begin
   Ft1 := filtro1.Text;
   Ft2 := filtro2.Text;
end;
if Ft1 = '' then abort;
if comboopcao.ItemIndex in [0,1,2,3] then begin
   if filtro = '' then
   filtro := 'select * from '+trim(tabela.Text) +
             ' where '+campo.Text + ' ' + OP + ' ' + QuotedStr(Ft1)+' '
   else
   Filtro := Filtro + ' and '+campo.Text + op + quotedStr(Ft1);
   end;

if comboopcao.ItemIndex in [4] then begin
   if filtro = '' then
   filtro := 'select * from '+trim(tabela.Text) +
             ' where '+campo.Text + ' ' + OP + ' ' +
             QuotedStr(Ft1) + ' and ' + QuotedStr(Ft2)
   else
   Filtro := Filtro + ' and '+campo.Text + op + QuotedStr(Ft1)+ ' and '+QuotedStr(Ft2);
   end;
if comboopcao.ItemIndex in [5] then begin
   if filtro = '' then
   filtro := 'select * from '+trim(tabela.Text) +
             ' where '+campo.Text + ' ' + OP + ' ' +
             '''%' + filtro1.Text + '%'''
   else
   Filtro := Filtro + ' and '+ campo.Text + ' ' + op + ' '+'''%'+Ft1+'%''';
   end;
LFiltro.Items.Add('Campo: '+trim(campo.text)+' '+Trim(ComboOpcao.Text)+' "'+ filtro1.Text + '" ' + filtro2.Text +'"');
filtro1.Clear;
filtro2.Clear;
filtro1.SetFocus;
end;

procedure TfrmForm.SpeedButton5Click(Sender: TObject);
begin
if tabela.Text = '' then abort;
tabelachange(self);
end;

procedure TfrmForm.DSStateChange(Sender: TObject);
begin
if dados.TABELA.State in [dsinsert] then begin
  if Inc = true then begin
     with dados.Query do begin
       close;
       sql.Clear;
       sql.Text := 'select max('+Icampo+') from '+trim(tabela.Text);
       open;
       dados.TABELA.FieldByName(ICampo).AsInteger := 1 + dados.Query.Fields.Fields[0].AsInteger;
       close;
       end;
  end;
  if Dtd = true then ds.DataSet.FieldByName(dcampo).AsDateTime := date;
  FormCad.Foco.Execute;
end;
end;

procedure TfrmForm.DBGrid1DblClick(Sender: TObject);
begin
btCad.Click;
end;

procedure TfrmForm.ComboopcaoCloseUp(Sender: TObject);
begin
filtro1.SetFocus;
end;

procedure TfrmForm.btOrdenarClick(Sender: TObject);
begin
dados.TABELA.IndexFieldNames := '';
edit1.Clear;
OrdCampos.ItemIndex := -1;
end;

procedure TfrmForm.OrdCamposCloseUp(Sender: TObject);
begin
if OrdCampos.Text = '' then abort;
if frmConfigurar.TipoCampo(dados.TABELA.fieldbyname(trim(OrdCampos.Text)).DataType) = 'MEMORANDO' then begin
   showmessage('Campo do Tipo Memorando No Pode Ser Usado para Ordenao');
   OrdCampos.ItemIndex := -1;
   abort;
   end;
if AnsiContainsText(edit1.Text,trim(OrdCampos.Text)) = true
   then abort;
if Edit1.Text = '' then
   Edit1.Text := Edit1.Text + OrdCampos.Text else
   Edit1.Text := Edit1.Text + ';' + OrdCampos.Text;
   dados.TABELA.IndexFieldNames := edit1.Text;
OrdCampos.ItemIndex := -1;
end;

procedure TfrmForm.ModificarExecute(Sender: TObject);
Var i : integer;
begin
UpSql := '';
UpSql := 'Update '+Trim(Tabela.Text) + ' set ';
Campo.ItemIndex := 0;
for i := 1 to Campo.Items.Count do begin
    if Campo.ItemIndex < campo.Items.Count - 1 then
    UpSql := UpSql + Trim(Campo.Text)+ ' = :'+Trim(Campo.Text)+', ' else
    UpSql := UpSql + Trim(Campo.Text)+ ' = :'+Trim(Campo.Text);
    Campo.ItemIndex := Campo.ItemIndex + 1;
    end;
UpSql := UpSql + ' where ';
Campo.ItemIndex := 0;
for i := 1 to Campo.Items.Count do begin
    if Campo.ItemIndex < campo.Items.Count - 1 then
    UpSql := UpSql + Trim(Campo.Text)+' = :'+Trim(Campo.Text)+' and ' else
    UpSql := UpSql + Trim(Campo.Text)+' = :'+Trim(Campo.Text);
    Campo.ItemIndex := Campo.ItemIndex + 1;
    end;
Campo.ItemIndex := 0;
//dados.IBUP.ModifySQL.Text:=UpSql;
end;

procedure TfrmForm.InserirExecute(Sender: TObject);
Var i : integer;
begin
UpSql := '';
UpSql := 'insert into '+Trim(Tabela.Text) + ' (';
Campo.ItemIndex := 0;
for i := 1 to Campo.Items.Count do begin
    if Campo.ItemIndex < campo.Items.Count - 1 then
    UpSql := UpSql + Trim(Campo.Text)+ ', ' else
    UpSql := UpSql + Trim(Campo.Text)+ ')';
    Campo.ItemIndex := Campo.ItemIndex + 1;
    end;
UpSql := UpSql +' values ' +'(';
Campo.ItemIndex := 0;
for i := 1 to Campo.Items.Count do begin
    if Campo.ItemIndex < campo.Items.Count - 1 then
    UpSql := UpSql + ':'+Trim(Campo.Text)+ ', ' else
    UpSql := UpSql + ':'+Trim(Campo.Text)+ ')';
    Campo.ItemIndex := Campo.ItemIndex + 1;
    end;
Campo.ItemIndex := 0;
//dados.IBUP.InsertSQL.Text :=UpSql;
end;

procedure TfrmForm.DeletarExecute(Sender: TObject);
Var i : integer;
begin
UpSql := '';
IbCampo := '';
UpSql := 'delete from '+Trim(Tabela.Text) + ' where ';
Campo.ItemIndex := 0;
for i := 1 to Campo.Items.Count do begin
    if Campo.ItemIndex < campo.Items.Count - 1 then begin
    ibcampo := ibcampo + trim(campo.Text)+' = ' + dados.TABELA.fieldbyname(trim(campo.Text)).AsString+#13;
    UpSql := UpSql + Trim(Campo.Text)+ ' = :OLD_'+Trim(Campo.Text)+' and ';
    end else begin
    UpSql := UpSql + Trim(Campo.Text)+ ' = :OLD_'+Trim(Campo.Text);
    ibcampo := ibcampo + trim(campo.Text)+' = ' + dados.TABELA.fieldbyname(trim(campo.Text)).AsString;
    end;
    Campo.ItemIndex := Campo.ItemIndex + 1;
    end;
Campo.ItemIndex := 0;
dados.IBU.DeleteSQL.Text :=UpSql;
end;

procedure TfrmForm.AtualizarExecute(Sender: TObject);
Var i : integer;
begin
UpSql := '';
UpSql := 'select ';
Campo.ItemIndex := 0;
for i := 1 to Campo.Items.Count do begin
    if Campo.ItemIndex < campo.Items.Count - 1 then
    UpSql := UpSql + Trim(Campo.Text)+ ', ' else
    UpSql := UpSql + Trim(Campo.Text)+ ' from '+Trim(Tabela.Text)+' where ';
    Campo.ItemIndex := Campo.ItemIndex + 1;
    end;
Campo.ItemIndex := 0;
for i := 1 to Campo.Items.Count do begin
    if Campo.ItemIndex < campo.Items.Count - 1 then
    UpSql := UpSql + Trim(Campo.Text)+' = :'+Trim(Campo.Text)+' and ' else
    UpSql := UpSql + Trim(Campo.Text)+' = :'+Trim(Campo.Text);
    Campo.ItemIndex := Campo.ItemIndex + 1;
    end;
Campo.ItemIndex := 0;
//dados.IBUP.RefreshSQL.Text :=UpSql;
end;

end.
