unit Login;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, jpeg, ExtCtrls, Buttons, StdCtrls;

type
  TfrmLogin = class(TForm)
    Image1: TImage;
    Bevel1: TBevel;
    Login: TLabeledEdit;
    Senha: TLabeledEdit;
    SpeedButton1: TSpeedButton;
    procedure FormShow(Sender: TObject);
    procedure LoginExit(Sender: TObject);
    procedure SenhaExit(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure LoginKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SenhaKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmLogin: TfrmLogin;

implementation

uses DataModule;

{$R *.dfm}

procedure TfrmLogin.FormShow(Sender: TObject);
begin
login.SetFocus;
end;

procedure TfrmLogin.LoginExit(Sender: TObject);
begin
if not dados.IBS.Locate('login',login.Text,[]) then begin
   showmessage('Usurio no Cadastrado!');
   Login.SetFocus;
   abort;
end;end;

procedure TfrmLogin.SenhaExit(Sender: TObject);
begin
if dados.IBS.FieldByName('senha').AsString <> senha.Text then
begin
showmessage('Senha Invlida');
senha.SetFocus;
abort;
end;end;

procedure TfrmLogin.SpeedButton1Click(Sender: TObject);
begin
if dados.IBS.FieldByName('senha').AsString <> senha.Text then
begin
showmessage('Senha Invlida');
senha.SetFocus;
abort;
end else begin
frmLogin.Close;
end;end;

procedure TfrmLogin.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
if not dados.IBS.Locate('login',login.Text,[]) then application.Terminate;
if dados.IBS.FieldByName('senha').AsString <> senha.Text then application.Terminate;
end;

procedure TfrmLogin.LoginKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = 13 then senha.SetFocus;
end;

procedure TfrmLogin.SenhaKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = 13 then speedbutton1.Click;
end;

end.
